﻿@using System.Web.UI.WebControls;
@using DevExpress.Web.Mvc;
@using DevExpress.Web.Mvc.UI;
@using DevExpress.Utils;
@using Toyota.Common.Web.Html;
@using Toyota.Common.Web.Html.Helper;
@Html.Common().DevExpress().GridView(
grid =>    {

    grid.Name = "GridPOApporval";
    grid.Width = Unit.Percentage(100);
    grid.Height = Unit.Percentage(100);
    grid.Settings.ShowFilterRow = true;
    grid.Settings.ShowFilterRowMenu = true;
    grid.Settings.ShowColumnHeaders = true;
    grid.KeyFieldName = "PO_NO";

    grid.CallbackRouteValues = new { Controller = "D31203", Action = "PartialDatas" };
    grid.ClientSideEvents.BeginCallback = "OnBeginCallbackGrid";
    grid.SettingsBehavior.AllowSelectSingleRowOnly = false;
    grid.SettingsBehavior.AllowSelectByRowClick = true;
    grid.ClientSideEvents.EndCallback = "OnEndCallbackGrid";
    grid.ClientSideEvents.Init = "gridPOApproval_Init";   

    grid.Settings.HorizontalScrollBarMode = ScrollBarMode.Visible;
    grid.Settings.VerticalScrollBarMode = ScrollBarMode.Hidden;
    grid.Styles.Header.HorizontalAlign = HorizontalAlign.Center;
    grid.Styles.Header.VerticalAlign = VerticalAlign.Middle;

    grid.SettingsPager.FirstPageButton.Visible = true;
    grid.SettingsPager.LastPageButton.Visible = true;
    grid.SettingsPager.ShowNumericButtons = true;
    grid.SettingsPager.Position = PagerPosition.Bottom;
    grid.SettingsPager.PageSizeItemSettings.Visible = true;
    grid.SettingsPager.PageSizeItemSettings.Items = new string[] { "10", "30", "50", "100" };
    grid.SettingsPager.PageSizeItemSettings.Caption = "Page size";
    
    grid.CommandColumn.Visible = true;
    grid.CommandColumn.Width = Unit.Pixel(40);
    grid.CommandColumn.ClearFilterButton.Visible = true;
    grid.CommandColumn.ShowSelectCheckbox = true;

    grid.ClientSideEvents.SelectionChanged = "GridPOApporval_SelectionChange";

    grid.CustomJSProperties = (s, e) =>
    {
        MVCxGridView grid1 = (MVCxGridView)s;
        int startIndex = grid1.PageIndex * grid.SettingsPager.PageSize;
        int end = Math.Min(grid1.VisibleRowCount, startIndex + grid.SettingsPager.PageSize);
        //--=== List object
        object[] PROD_MONTH = new object[end - startIndex];
        object[] PO_NO = new object[end - startIndex];
        object[] LP_CD = new object[end - startIndex];


        for (int n = startIndex; n < end; n++)
        {
            PROD_MONTH[n - startIndex] = grid1.GetRowValues(n, "PROD_MONTH");
            PO_NO[n - startIndex] = grid1.GetRowValues(n, "PO_NO");
            LP_CD[n - startIndex] = grid1.GetRowValues(n, "LP_CD");

        }
        e.Properties["cpPROD_MONTH"] = PROD_MONTH;
        e.Properties["cpPO_NO"] = PO_NO;
        e.Properties["cpLP_CD"] = LP_CD;

        grid1.JSProperties["cpStart"] = startIndex;
        grid1.JSProperties["cpEnd"] = end;
        grid1.JSProperties["cpPageSize"] = grid.SettingsPager.PageSize;
    };

    grid.Columns.Add(
                      pic =>
                      {
                          pic.Name = "PROD_MONTH";
                          pic.FieldName = "PROD_MONTH";
                          pic.Caption = "Production <br />Month";
                          pic.Width = Unit.Pixel(80);
                          //pic.HeaderStyle.Font.Bold = true;
                          pic.HeaderStyle.HorizontalAlign = HorizontalAlign.Center;
                          pic.CellStyle.HorizontalAlign = HorizontalAlign.Center;
                          pic.CellStyle.VerticalAlign = VerticalAlign.Middle;
                          pic.Settings.AutoFilterCondition = AutoFilterCondition.Contains;
                      });

    grid.Columns.Add(
        column =>
        {
            column.Name = "PO_NO";
            column.FieldName = "PO_NO";
            column.Caption = "PO Number";
            column.Width = Unit.Pixel(100);
            //column.HeaderStyle.Font.Bold = true;
            column.HeaderStyle.HorizontalAlign = HorizontalAlign.Center;
            column.CellStyle.HorizontalAlign = HorizontalAlign.Center;
            column.CellStyle.VerticalAlign = VerticalAlign.Middle;
            column.Settings.AutoFilterCondition = AutoFilterCondition.Contains;
            column.SetDataItemTemplateContent(
                content =>
                {
                    GridViewDataItemTemplateContainer c = (GridViewDataItemTemplateContainer)content;
                    Html.DevExpress().HyperLink(
                        link =>
                        {
                            link.Name = "lnkPO_NO" + content.VisibleIndex;
                            link.NavigateUrl = "javascript:void(0)";
                            link.Properties.Text = content.Text;
                            link.ClientVisible = true;
                            link.Properties.ClientSideEvents.Click = string.Format("function(s, e) {{ OnPOClick('{0}'); }}", (content as GridViewDataItemTemplateContainer).Text);

                        }).Render();
                });
        });

    //-------[ PO STATUS BEGIN ]--------
    grid.Columns.AddBand(
    columnBand =>
    {
        columnBand.Caption = "Status";
        columnBand.Columns.Add(
            shpr =>
            {
                shpr.Settings.ShowFilterRowMenu = DefaultBoolean.False;
                shpr.Settings.AllowAutoFilter = DefaultBoolean.False;
                shpr.Caption = "SH";
                shpr.Name = "SH_APPROVED_DT";
                shpr.FieldName = "SH_APPROVED_DT";
                shpr.Width = Unit.Pixel(50);
                shpr.HeaderStyle.HorizontalAlign = HorizontalAlign.Center;

                shpr.CellStyle.VerticalAlign = VerticalAlign.Middle;
                shpr.CellStyle.HorizontalAlign = HorizontalAlign.Center;

                shpr.SetDataItemTemplateContent(
                    dtshpr =>
                    {

                        Html.DevExpress().Image(
                            img =>
                            {
                                img.Properties.ImageAlign = ImageAlign.Middle;
                                img.ImageUrl = "~/Content/Images/" + dtshpr.Text + ".png"; //"~/Content/Images/Green.png";

                            }).Render();
                    });


            }
            );


        columnBand.Columns.Add(
            dphpr =>
            {
                dphpr.Settings.ShowFilterRowMenu = DefaultBoolean.False;
                dphpr.Settings.AllowAutoFilter = DefaultBoolean.False;
                dphpr.Caption = "DpH";
                dphpr.Name = "DPH_APPROVED_DT";
                dphpr.FieldName = "DPH_APPROVED_DT";
                dphpr.Width = Unit.Pixel(50);
                dphpr.HeaderStyle.HorizontalAlign = HorizontalAlign.Center;
                dphpr.CellStyle.VerticalAlign = VerticalAlign.Middle;
                dphpr.CellStyle.HorizontalAlign = HorizontalAlign.Center;

                dphpr.SetDataItemTemplateContent(
                    dtdphpr =>
                    {
                        Html.DevExpress().Image(
                            img =>
                            {
                                img.Properties.ImageAlign = ImageAlign.Middle;
                                img.ImageUrl = "~/Content/Images/" + dtdphpr.Text + ".png"; ;
                            }).Render();
                    });


            }
            );
        columnBand.Columns.Add(
            dhpr =>
            {
                dhpr.Settings.ShowFilterRowMenu = DefaultBoolean.False;
                dhpr.Settings.AllowAutoFilter = DefaultBoolean.False;
                dhpr.Caption = "DH";
                dhpr.Name = "DH_APPROVED_DT";
                dhpr.FieldName = "DH_APPROVED_DT";
                dhpr.Width = Unit.Pixel(50);
                dhpr.HeaderStyle.HorizontalAlign = HorizontalAlign.Center;
                dhpr.CellStyle.VerticalAlign = VerticalAlign.Middle;
                dhpr.CellStyle.HorizontalAlign = HorizontalAlign.Center;

                dhpr.SetDataItemTemplateContent(
                    dtdhpr =>
                    {
                        Html.DevExpress().Image(
                            img =>
                            {
                                img.Properties.ImageAlign = ImageAlign.Middle;
                                img.ImageUrl = "~/Content/Images/" + dtdhpr.Text + ".png";
                            }).Render();
                    });


            }
            );


    }
    );
    //-------------------[ PO STATUS END ]----------------------------
    grid.Columns.Add(
                      pic =>
                      {
                          pic.Name = "CURRENT_PIC";
                          pic.FieldName = "CREATED_BY";
                          pic.Caption = "Current PIC";

                          pic.Width = Unit.Pixel(140);
                          pic.HeaderStyle.HorizontalAlign = HorizontalAlign.Center;
                          pic.CellStyle.HorizontalAlign = HorizontalAlign.Left;
                          pic.CellStyle.VerticalAlign = VerticalAlign.Middle;
                          pic.Settings.AutoFilterCondition = AutoFilterCondition.Contains;
                      });

    grid.Columns.Add(
                  prdate =>
                  {

                      prdate.Caption = "PO Date";
                      prdate.Name = "CREATED_DT";
                      prdate.FieldName = "CREATED_DT";
                      //prdate.ColumnType = MVCxGridViewColumnType.DateEdit;
                      //prdate.PropertiesEdit.DisplayFormatString = "dd.MM.yyyy HH:mm";
                      prdate.ColumnType = MVCxGridViewColumnType.DateEdit;
                      prdate.PropertiesEdit.DisplayFormatString = "dd.MM.yyyy";
                      var dateEditProperties = prdate.PropertiesEdit as DateEditProperties;
                      dateEditProperties.EditFormat = EditFormat.DateTime;
                      dateEditProperties.EditFormatString = "dd.MM.yyyy";
                      dateEditProperties.UseMaskBehavior = true;
                      prdate.Width = Unit.Pixel(90);
                      prdate.CellStyle.HorizontalAlign = HorizontalAlign.Center;
                      prdate.Settings.AutoFilterCondition = AutoFilterCondition.Equals;
                  });
    
    grid.Columns.AddBand(
        columnBand =>
        {
            columnBand.Caption = "Trucking";

            columnBand.Columns.Add(
                codepartner =>
                {
                    codepartner.Name = "LP_CD";
                    codepartner.FieldName = "LP_CD";
                    codepartner.Caption = "Code";
                    codepartner.Width = Unit.Pixel(50);
                    //codepartner.Width = Unit.Percentage(40);
                    codepartner.HeaderStyle.HorizontalAlign = HorizontalAlign.Center;
                    codepartner.CellStyle.HorizontalAlign = HorizontalAlign.Center;
                    codepartner.CellStyle.VerticalAlign = VerticalAlign.Middle;
                    codepartner.Settings.AutoFilterCondition = AutoFilterCondition.Contains;
                });

            columnBand.Columns.Add(
                lopartner =>
                {
                    lopartner.Name = "LOG_PARTNER_NAME";
                    lopartner.FieldName = "LOG_PARTNER_NAME";
                    lopartner.Caption = "Name";

                    lopartner.Width = Unit.Pixel(220);
                    lopartner.HeaderStyle.HorizontalAlign = HorizontalAlign.Center;
                    lopartner.CellStyle.HorizontalAlign = HorizontalAlign.Left;
                    lopartner.CellStyle.VerticalAlign = VerticalAlign.Middle;
                    lopartner.Settings.AutoFilterCondition = AutoFilterCondition.Contains;
                });




        }
        );

    //===============================================================================================================================
    //-------[ Release By ]--------
    grid.Columns.AddBand(
        columnBand =>
        {
            columnBand.Caption = "Released By";
            columnBand.Name = "RELEASE_BY";
            columnBand.Visible = true;
            columnBand.Columns.Add(
                shpr13 =>
                {
                    //shpr.Settings.ShowFilterRowMenu = DefaultBoolean.False;
                    //shpr.Settings.AllowAutoFilter = DefaultBoolean.False;
                    shpr13.Caption = "SH";
                    shpr13.Name = "SH_RELEASE_BY";
                    shpr13.FieldName = "SH_RELEASE_BY";
                    shpr13.Width = Unit.Pixel(140);
                    shpr13.HeaderStyle.HorizontalAlign = HorizontalAlign.Center;
                    shpr13.CellStyle.VerticalAlign = VerticalAlign.Middle;
                    shpr13.CellStyle.HorizontalAlign = HorizontalAlign.Left;

                }
                );

            columnBand.Columns.Add(
                shpr14 =>
                {
                    //shpr.Settings.ShowFilterRowMenu = DefaultBoolean.False;
                    //shpr.Settings.AllowAutoFilter = DefaultBoolean.False;
                    shpr14.Caption = "DpH";
                    shpr14.Name = "DPH_RELEASE_BY";
                    shpr14.FieldName = "DPH_RELEASE_BY";
                    shpr14.Width = Unit.Pixel(140);
                    shpr14.HeaderStyle.HorizontalAlign = HorizontalAlign.Center;
                    shpr14.CellStyle.VerticalAlign = VerticalAlign.Middle;
                    shpr14.CellStyle.HorizontalAlign = HorizontalAlign.Left;
                }
                );


            columnBand.Columns.Add(
                shpr19 =>
                {
                    //shpr.Settings.ShowFilterRowMenu = DefaultBoolean.False;
                    //shpr.Settings.AllowAutoFilter = DefaultBoolean.False;
                    shpr19.Caption = "DH";
                    shpr19.Name = "DH_RELEASE_BY";
                    shpr19.FieldName = "DH_RELEASE_BY";
                    shpr19.Width = Unit.Pixel(140);
                    shpr19.HeaderStyle.HorizontalAlign = HorizontalAlign.Center;
                    shpr19.CellStyle.VerticalAlign = VerticalAlign.Middle;
                    shpr19.CellStyle.HorizontalAlign = HorizontalAlign.Left;
                }
                );
        }
        );

    //-------[ RELEASE DATE ]-------- TOOGLE-----------------------------------
    grid.Columns.AddBand(
    columnBand =>
    {
        columnBand.Caption = "Released Date";
        columnBand.Name = "RELEASE_DATE";
        columnBand.Visible = false;
        columnBand.Columns.Add(
            RSH =>
            {
                RSH.Name = "RSH";
                RSH.FieldName = "SH_RELEASE";
                RSH.Caption = "SH";
                //RSH.ColumnType = MVCxGridViewColumnType.DateEdit;
                //RSH.PropertiesEdit.DisplayFormatString = "dd.MM.yyyy HH:mm";
                RSH.ColumnType = MVCxGridViewColumnType.DateEdit;
                RSH.PropertiesEdit.DisplayFormatString = "dd.MM.yyyy HH:mm";
                var dateEditProperties = RSH.PropertiesEdit as DateEditProperties;
                dateEditProperties.EditFormat = EditFormat.DateTime;
                dateEditProperties.EditFormatString = "dd.MM.yyyy";
                dateEditProperties.UseMaskBehavior = true;
                RSH.Width = Unit.Pixel(120);
                RSH.HeaderStyle.HorizontalAlign = HorizontalAlign.Center;
                RSH.CellStyle.HorizontalAlign = HorizontalAlign.Center;
                RSH.CellStyle.VerticalAlign = VerticalAlign.Middle;
            });

        columnBand.Columns.Add(
            DPH =>
            {
                DPH.Name = "DPH";
                DPH.FieldName = "DPH_RELEASE";
                DPH.Caption = "DpH";
                //DPH.ColumnType = MVCxGridViewColumnType.DateEdit;
                //DPH.PropertiesEdit.DisplayFormatString = "dd.MM.yyyy HH:mm";
                DPH.ColumnType = MVCxGridViewColumnType.DateEdit;
                DPH.PropertiesEdit.DisplayFormatString = "dd.MM.yyyy HH:mm";
                var dateEditProperties = DPH.PropertiesEdit as DateEditProperties;
                dateEditProperties.EditFormat = EditFormat.DateTime;
                dateEditProperties.EditFormatString = "dd.MM.yyyy";
                dateEditProperties.UseMaskBehavior = true;
                DPH.Width = Unit.Pixel(120);
                DPH.HeaderStyle.HorizontalAlign = HorizontalAlign.Center;
                DPH.CellStyle.HorizontalAlign = HorizontalAlign.Center;
                DPH.CellStyle.VerticalAlign = VerticalAlign.Middle;
            });

        columnBand.Columns.Add(
            DH =>
            {
                DH.Name = "DH";
                DH.FieldName = "DH_RELEASE";
                DH.Caption = "DH";
                //DH.ColumnType = MVCxGridViewColumnType.DateEdit;
                //DH.PropertiesEdit.DisplayFormatString = "dd.MM.yyyy HH:mm";
                DH.ColumnType = MVCxGridViewColumnType.DateEdit;
                DH.PropertiesEdit.DisplayFormatString = "dd.MM.yyyy HH:mm";
                var dateEditProperties = DH.PropertiesEdit as DateEditProperties;
                dateEditProperties.EditFormat = EditFormat.DateTime;
                dateEditProperties.EditFormatString = "dd.MM.yyyy";
                dateEditProperties.UseMaskBehavior = true;
                DH.Width = Unit.Pixel(120);
                DH.HeaderStyle.HorizontalAlign = HorizontalAlign.Center;
                DH.CellStyle.HorizontalAlign = HorizontalAlign.Center;
                DH.CellStyle.VerticalAlign = VerticalAlign.Middle;
            });


    }
    );
    
    //===============================================================================================================================
    //-------[ PR STATUS BEGIN ]--------
    grid.Columns.AddBand(
        columnBand =>
        {
            columnBand.Caption = "PO Rejection";
            columnBand.Name = "PO_REJECT";
            columnBand.Visible = false;
            columnBand.Columns.Add(
                shpr =>
                {
                    shpr.Caption = "By";
                    shpr.Name = "REJECTED_BY";
                    shpr.FieldName = "REJECTED_BY";
                    shpr.Width = Unit.Pixel(140);
                    shpr.HeaderStyle.HorizontalAlign = HorizontalAlign.Center;
                    shpr.CellStyle.VerticalAlign = VerticalAlign.Middle;
                    shpr.CellStyle.HorizontalAlign = HorizontalAlign.Left;

                }
                );

            columnBand.Columns.Add(
            pos =>
            {
                pos.Caption = "Position";
                pos.Name = "REJECTED_POSITION";
                pos.FieldName = "REJECTED_POSITION";
                pos.Width = Unit.Pixel(100);
                pos.HeaderStyle.HorizontalAlign = HorizontalAlign.Center;
                pos.CellStyle.HorizontalAlign = HorizontalAlign.Center;
                pos.CellStyle.VerticalAlign = VerticalAlign.Middle;
                pos.Settings.AutoFilterCondition = AutoFilterCondition.Contains;



            });
            
            columnBand.Columns.Add(
                dphpr =>
                {
                    dphpr.Caption = "Date";
                    dphpr.Name = "REJECTED_DT";
                    dphpr.FieldName = "REJECTED_DT";
                    dphpr.Width = Unit.Pixel(120);
                    dphpr.HeaderStyle.HorizontalAlign = HorizontalAlign.Center;
                    dphpr.CellStyle.VerticalAlign = VerticalAlign.Middle;
                    dphpr.CellStyle.HorizontalAlign = HorizontalAlign.Center;
                    dphpr.ColumnType = MVCxGridViewColumnType.DateEdit;
                    dphpr.PropertiesEdit.NullDisplayText = "";
                    dphpr.PropertiesEdit.DisplayFormatString = "dd.MM.yyyy HH:mm";
                    var dateEditProperties = dphpr.PropertiesEdit as DateEditProperties;
                    dateEditProperties.EditFormatString = "dd.MM.yyyy";
                    dateEditProperties.UseMaskBehavior = true;

                    
                });
        }
        );
}).Bind(Model.GetModel<Portal.Models.Delivery.POApproval.POApprovalModel>().POApprovalDatas).GetHtml()
  
                    
                     